package eu.mhsl.craftattack.spawn.appliances.report.command;

import eu.mhsl.craftattack.spawn.Main;
import eu.mhsl.craftattack.spawn.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.appliances.report.Report;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Bukkit;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class ReportCommand extends ApplianceCommand.PlayerChecked<Report> {
    public ReportCommand() {
        super("report");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if(args.length == 0) {
            sender.sendMessage(
                    Component
                            .text("Bitte gib einen Spieler an, den du reporten möchtest!", NamedTextColor.RED)
                            .appendNewline()
                            .append(Component.text("/report <spieler> [grund]", NamedTextColor.RED))
            );
            return;
        }

        sender.sendMessage(
                Component.newline()
                        .append(Component.text("Reportanfrage wird erstellt...", NamedTextColor.GREEN))
                        .appendNewline()
                        .append(Component.text("Bitte warte einen Augenblick", NamedTextColor.GRAY))
                        .appendNewline()
        );

        Bukkit.getScheduler().runTask(Main.instance(), () -> {
            getAppliance().issueReport(
                    getPlayer(),
                    args[0],
                    Arrays.stream(args).skip(1).collect(Collectors.joining(" "))
            );
        });
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        List<String> response = new ArrayList<>();

        if(args.length == 1) {
            response = Stream.concat(
                    Bukkit.getOnlinePlayers().stream().map(Player::getName),
                    Arrays.stream(Bukkit.getOfflinePlayers()).map(OfflinePlayer::getName)
            ).toList();
        }

        if(args.length == 2) {
            response = List.of(
                    "Griefing",
                    "Diebstahl",
                    "Beleidigung",
                    "Hacking",
                    "Andere Regelverstöße",
                    " "
            );
        }

        return super.tabCompleteReducer(response, args);
    }
}
